MyRole = LibStub("AceAddon-3.0"):NewAddon("MyRole","AceEvent-3.0")
local ldb = LibStub("LibDataBroker-1.1")

local roletable = {
	["none"] = {
		["icon"] = "Interface\\Addons\\MyRole\\icon",
		["text"] = "No Role",
	},
	["dps"] = {
		["icon"] = "Interface\\Addons\\MyRole\\dps",
		["text"] = "DPS",
	},
	["tank"] = {
		["icon"] = "Interface\\Addons\\MyRole\\tank",
		["text"] = "Tank",
	},
	["healer"] = {
		["icon"] = "Interface\\Addons\\MyRole\\heal",
		["text"] = "Healer",
	},
}

MyRole.dataobject = ldb:NewDataObject("MyRole", {
	["type"] = "data source",
	["text"] = roletable.none.text,
	["icon"] = roletable.none.icon,
})


local function Update()
	local isTank, isHealer, isDamage = UnitGroupRolesAssigned("player")
	
	if isTank then
		MyRole.dataobject.icon = roletable.tank.icon
		MyRole.dataobject.text = roletable.tank.text
	elseif isHealer then
		MyRole.dataobject.icon = roletable.healer.icon
		MyRole.dataobject.text = roletable.healer.text
	elseif isDamage then
		MyRole.dataobject.icon = roletable.dps.icon
		MyRole.dataobject.text = roletable.dps.text
	else
		MyRole.dataobject.icon = roletable.none.icon
		MyRole.dataobject.text = roletable.none.text
	end
end

function MyRole:OnEnable()
	-- I couldn't find a single event that was reliable, so since the function is short I'm just hooking pretty much everything
	-- Honestly I might as well have just hooked "OnEvent" and updated it every 5 seconds.
	self:RegisterEvent("PLAYER_ROLES_ASSIGNED", Update)
	self:RegisterEvent("LFG_ROLE_UPDATE", Update)
	self:RegisterEvent("ZONE_CHANGED", Update)
	self:RegisterEvent("PARTY_MEMBERS_CHANGED", Update)
end